Graphics 512,512,0,2
SetBuffer BackBuffer()
SeedRnd MilliSecs()

Global grid[5000] ;64x64=4096
Global higrid[300000] ;512x512=262144
Global higrid2[300000] ;512x512=262144
Global Track#[500000]	; lots of pairs of co-ords
Global FinalTrack#[500000]	; lots of pairs of co-ords

Global Smooth
Global Push#=2.5
Global TrackLong=0

MakeTrack()
Repeat
	DrawFinal()

	If KeyDown(203) Then SmoothTrack(Smooth-1)
	If KeyDown(205) Then SmoothTrack(Smooth+1)
	
	If KeyDown(200) Then Push=Push-0.05:SmoothTrack(Smooth)
	If KeyDown(208) Then Push=Push+0.05:SmoothTrack(Smooth)
	
	
	If KeyDown(57) Then MakeTrack()
Until KeyDown(1)

Function MakeTrack()

	; 1 - Reset
	For n=0 To 4999:grid[n]=0:Next
	For n=0 To 299999:higrid[n]=0:higrid2[n]=0:Next
	For n=0 To 499999:Track[n]=0:FinalTrack[n]=0:Next
		
	; 2 - Mark Middle
	x=32:y=32
	grid[y*64+x]=1
	
	; 3 - Expand outward randomly
	p=0:z=Rand(8,64)
	Repeat
		; Random xy
		x=Rand(1,62):y=Rand(1,62):d=0
		If grid[y*64+x]=0	; If joined to another marked spot
			If grid[y*64+(x-1)]=1 Then grid[y*64+x]=1:d=1
			If grid[y*64+(x+1)]=1 Then grid[y*64+x]=1:d=1
			If grid[(y-1)*64+x]=1 Then grid[y*64+x]=1:d=1
			If grid[(y+1)*64+x]=1 Then grid[y*64+x]=1:d=1
		EndIf
		If d=1 Then p=p+1	; Mark spot
	Until p>z
	
	; 4 - Convert to higher resolution
	For x=0 To 511
	For y=0 To 511
		gx=Floor(x/8)
		gy=Floor(y/8)
		higrid[y*512+x]=grid[gy*64+gx]
	Next
	Next
	
	; 5 - Trace Outlines
	For x=1 To 510
	For y=1 To 510
		a=1
		If higrid[y*512+x]=1
			If higrid[y*512+(x+1)]=0 Or higrid[y*512+(x-1)]=0 Or higrid[(y-1)*512+x]=0 Or higrid[(y+1)*512+x]=0 Then higrid2[y*512+x]=1
		EndIf
	Next
	Next
	
	; 6 - Find a spot for the start
	x=256:y=0
	For n=0 To 256
		If higrid2[n*512+x]=1 And y=0 Then y=n
	Next
	
	Track[0]=x:Track[1]=y:TrackLong=0
	; Drive along the track, placing points into the Track array
	d=1
	x=Track[0]+1:y=Track[1]
	If higrid2[y*512+x]=0 Then d=0:x=Track[0]:y=Track[1]-1
	While x<>Track[0] Or y<>Track[1]
		; Check next step
		If (d=0 And higrid2[(y-1)*512+x]=0) Or (d=2 And higrid2[(y+1)*512+x]=0)	; If No track, turn
			If higrid2[y*512+(x-1)]=1 Then d=3
			If higrid2[y*512+(x+1)]=1 Then d=1
		EndIf
		If (d=1 And higrid2[(y)*512+(x+1)]=0) Or (d=3 And higrid2[(y)*512+(x-1)]=0)
			If higrid2[(y+1)*512+(x)]=1 Then d=2
			If higrid2[(y-1)*512+(x)]=1 Then d=0
		EndIf
	
		; Move
		If d=0 Then y=y-1:If y<1 Then y=1:d=-1
		If d=1 Then x=x+1:If x>511 Then x=511:d=-1
		If d=2 Then y=y+1:If y>511 Then y=511:d=-1
		If d=3 Then x=x-1:If x<1 Then x=1:d=-1
		
		; Store point
		TrackLong=TrackLong+1
		Track[TrackLong*2]=x:Track[TrackLong*2+1]=y
		If TrackLong>200000 Or d=-1 Then x=Track[0]:y=Track[1]
	Wend 
	
	
	SmoothTrack(Rand(4,32))
End Function


Function SmoothTrack(Smoother) 
	; 7 - For each point, take average of pieces before and after, to help smooth turns
	Smooth=Smoother
	If Smooth<1 Then Smooth=1
	If Smooth>64 Then Smooth=64


	If Push<2 Then Push=2
	If Push>4 Then Push=4
	
	For n=0 To TrackLong
	UnSmooth#=1.0/(Float(Smooth)*Push)		
		avgx#=0:avgy#=0
		For s=-Smooth To Smooth
			t=n+s
			If t<=0 Then t=t+(TrackLong)
			If t>=TrackLong Then t=t-(TrackLong)
			t=t*2
			avgx=avgx+(Track[n*2]-Track[t]):avgy=avgy+(Track[n*2+1]-Track[t+1])
		Next
		avgx=avgx*UnSmooth
		avgy=avgy*UnSmooth
		FinalTrack[n*2]=Track[n*2]-avgx:FinalTrack[n*2+1]=Track[n*2+1]-avgy
	Next
End Function



Function DrawFinal()
Cls

; Draw Grid
Color 48,48,48
For x=0 To 63
For y=0 To 63
	If grid[y*64+x]=1 Then Rect(x*8,y*8,8,8)
Next
Next

; Overlay Border
Color 150,150,150
lf=0:rt=0:up=0:dwn=0
For x=0 To 511
For y=0 To 511
	If higrid2[y*512+x]=1
		Plot x,y
		If x-256<lf Then lf=x-256
		If x-256>rt Then rt=x-256
		If y-256<up Then up=y-256
		If y-256>dwn Then dwn=y-256
	EndIf
Next
Next
sc#=Abs(lf)
If rt>sc# Then sc#=rt
If Abs(up)>sc# Then sc#=Abs(up)
If dwn>sc# Then sc#=dwn

sc=250.0/sc
cx#=256.0+(Float(rt+lf)/2):cy#=256.0+(Float(dwn+up)/2)
; Overlay enlarged form of Track

For n=0 To TrackLong


	d=(((Floor(MilliSecs()/64)-n) Mod 8)*25)+50
	Color d,d,d
	
	x1=((FinalTrack[n*2]-(cx))*sc)+(256.0)
	y1=((FinalTrack[n*2+1]-cy)*sc)+256.0
	x2=((FinalTrack[n*2+2]-(cx))*sc)+(256.0)
	y2=((FinalTrack[n*2+3]-cy)*sc)+(256.0)
	If n=TrackLong
		x2=((FinalTrack[0]-(cx))*sc)+(256.0)
		y2=((FinalTrack[1]-cy)*sc)+256.0
	EndIf

	Plot x1,y1
	
Next

Color 255,255,255
Text 10,4, "Length  : "+TrackLong
Text 10,15,"Smooth  : "+Smooth+" (Left/Right)"
Text 10,26,"Angular : "+(Floor(Push*100.0)/100.0)+" (Up/Down)"
Text 10,37,"Space   : New Track"


Delay 4
Flip
End Function